<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Education;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\JsonResponse;
use Yajra\DataTables\Facades\DataTables;

class EducationController extends Controller
{
    public function index()
    {
        $educations = Education::orderBy('created_at', 'desc')->get();

        return view('admin.educations.index', compact('educations'));
    }

    public function getEducationList(Request $request)
    {
        $sqlBuilder = Education::select([
            'educations.id',
            'educations.name',
            'educations.name_ar',
            'educations.status',
        ]);

        return DataTables::of($sqlBuilder)
            ->filter(function ($query) use ($request) {
                if ($request->has('search') && !empty($request->search['value'])) {
                    $query->where('educations.name', 'ilike', "%" . $request->search['value'] . "%")
                    ->orWhere('educations.name_ar', 'ilike', "%" . $request->search['value'] . "%");
                }
            })
            ->editColumn('status', function ($data) {
                return '<div class="status">
                <div class="form-check form-switch ">
                    <input class="form-check-input status-checkbox" type="checkbox" role="switch" id="SwitchCheck4" data-url="' . route('admin.educations.status', ['id' => $data->id]) . '" data-id="' . $data->id . '" ' . (!empty($data->status) && $data->status == 1 ? 'checked' : '') . ' />
                </div>
            </div>';
            })
            ->addColumn('action', function ($data) {
                $html = '<div class="dropdown">
                                        <a href="#" class="btn btn-soft-secondary btn-sm" role="button" id="dropdownMenuLink5" data-bs-toggle="dropdown" aria-expanded="false">
                                            <i class="ri-more-2-fill"></i>
                                        </a>
                                        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink5">
                                            <li><a class="dropdown-item" href="' . route('admin.educations.edit', ['id' => $data->id]) . '">Edit</a></li>
                                            <li><a class="dropdown-item delete-btn" data-url="' . route('admin.educations.destroy', ['id' => $data->id]) . '">Delete</a></li>
                                        </ul>
                                    </div>';
                return $html;
            })
            ->rawColumns(['status', 'action'])
            ->make(true);
    }

    public function create()
    {
        $education = "";

        return view('admin.educations.create', compact('education'));
    }

    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|string|max:255',
            'name_ar' => 'required|string|max:255',
            'status' => 'required|in:0,1',
        ];

        $validator = Validator::make($request->all(), $rules);

        if ($validator->fails()) {
            return response()->json([
                'status' => 'error',
                'errors' => $validator->errors(),
            ], 422);
        }

        if ($request->id) {
            $education = Education::find($request->id);

            if (!$education) {
                return response()->json(['status' => 'error', 'message' => 'Education not found'], 404);
            }

            $education->name = $request->name;
            $education->name_ar = $request->name_ar;
            $education->status = $request->status;
            $education->save();

            return response()->json(['status' => 'success', 'message' => 'Education updated successfully']);
        } else {
            $education = Education::create([
                'name' => $request->name,
                'name_ar' => $request->name_ar,
                'status' => $request->status,
            ]);

            return response()->json(['status' => 'success', 'message' => 'Education added successfully', 'education' => $education]);
        }
    }

    public function edit($id)
    {
        $education = Education::findOrFail($id);

        return view('admin.educations.create', compact('education'));
    }

    public function destroy($id): JsonResponse
    {
        try {
            $education = Education::findOrFail($id);
            $education->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Education deleted successfully.'
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'Education not found.'
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'An error occurred while deleting the education.'
            ], 500);
        }
    }

    public function statusChange(Request $request, $id)
    {
        $education = Education::find($id);

        if (!$education) {
            return response()->json([
                'status' => 'error',
                'message' => 'Education not found.'
            ], 404);
        }

        $education->status = $request->status;
        $education->save();

        return response()->json([
            'status' => 'success',
            'message' => 'Education status updated successfully.'
        ]);
    }
}
